package com.rp.util.sort;

import com.rp.util.sort.ISort;
import com.rp.util.sort.SortException;
import com.rp.util.ReflectionUtil;
import java.util.Comparator;
import java.util.List;

public final class CombSort implements ISort
{
	
	public CombSort ()
	{}
	
	public void sort (int[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (int[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		int temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i] > arr[i+gap])  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (String[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (String[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		String temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i].compareToIgnoreCase (arr[i+gap]) > 0)  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (long[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (long[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		long temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i] > arr[i+gap])  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}

	public void sort (short[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (short[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		short temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i] > arr[i+gap])  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (double[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (double[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		double temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i] > arr[i+gap])  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (float[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (float[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		float temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i] > arr[i+gap])  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (char[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (char[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		char temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i] > arr[i+gap])  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (byte[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (byte[] arr, int begin, int end)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		byte temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
            	if (arr[i] > arr[i+gap])  
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (Object[] arr, Comparator c, String methodName) throws SortException
	{
		sort (arr, c, methodName, new Class[0], new Object[0]);	
	}
	
	public void sort (Object[] arr, Comparator c, String methodName, Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		sort (arr, 0, arr.length-1, c, methodName, paramTypes, paramValues);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName)  
							throws SortException
	{
		sort (arr, begin, end, c, methodName, new Class[0], new Object[0]);
	}
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName, 
							Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		try
		{
			int gap = end+1;
			int left = end+1;
			boolean swapFlag = true;
			Object temp;
			while (gap > 1 || swapFlag == true)
			{
				gap = gap * 10 / 13;
	    		if (gap < 1)
	    		{              
					gap = 1;
				}
				if (gap==9 || gap==10)     
				{
					gap=11;
				}
	 
				swapFlag = false;         
	
				for( int i = begin; i < left - gap; i++)
				{
					if (c.compare 
						(ReflectionUtil.getMethodValue (arr[i], methodName, paramTypes, paramValues), 
						ReflectionUtil.getMethodValue (arr[i+gap], methodName, paramTypes, paramValues)) > 0)
	            	{
	            		temp = arr[i];    
						arr[i] = arr[i+gap];
						arr[i+gap] = temp;
						swapFlag = true;    
					}
				}
			}
		}
		catch (Exception e)
		{
			throw new SortException (e);	
		}
	}
	
	public void sort (Object[] arr, Comparator c)
	{
		
		sort (arr, 0, arr.length-1, c);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		Object temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
				if (c.compare(arr[i], arr[i+gap]) > 0)
            	{
            		temp = arr[i];    
					arr[i] = arr[i+gap];
					arr[i+gap] = temp;
					swapFlag = true;    
				}
			}
		}
	}
	
	public void sort (List arr, Comparator c)
	{
	
		sort (arr, 0, arr.size()-1, c);	
	}
	
	public void sort (List arr, int begin, int end, Comparator c)
	{
		int gap = end+1;
		int left = end+1;
		boolean swapFlag = true;
		Object temp;
		while (gap > 1 || swapFlag == true)
		{
			gap = gap * 10 / 13;
    		if (gap < 1)
    		{              
				gap = 1;
			}
			if (gap==9 || gap==10)     
			{
				gap=11;
			}
 
			swapFlag = false;         

			for( int i = begin; i < left - gap; i++)
			{
				if (c.compare(arr.get(i), arr.get(i+gap)) > 0)
            	{
            		temp = arr.get(i);    
            		arr.set(i, arr.get(i+gap));
					arr.set(i+gap, temp);
					swapFlag = true;    
				}
			}
		}
	}
}