package test.sort;

import test.sort.SortTime;
import test.sort.IObject;
import test.sort.IObjectCompare;
import test.util.ArrayPrint;
import com.rp.util.test.RandomArrayGenerator;
import com.rp.util.sort.*;
import com.rp.util.sort.compare.IntegerComparator;
import timer.ITimer;
import timer.HTimer;

public class TimerTest
{
	
	public static void main (String[] args)
	{
		if (args.length != 4)
		{
			System.out.println ("USAGE: ARRAY_SIZE TYPE NUMBER_OF_TRIES SORT_CLASS");
			System.out.println ("EXAMPLE: java test/sort/TimerTest 100 int 50 HeapSort");
			System.out.println ("SORT TYPES:");
			System.out.println ("InsertionSort, InsertionSortBinarySearch, MergeSort, MergeInsertionSort, ");
			System.out.println ("QuickSort, QuickInsertionSort, QuickSortMedian3, QuickSortRandom, ");
			System.out.println ("HeapSort, BubbleSort, ShellSort, CombSort");
			System.exit(0);	
		}
		
		int count = (new Integer(args[0])).intValue();
		String type = args[1];
		int tries = (new Integer(args[2])).intValue();
		ITimer t = new HTimer();
		String sortType = args[3];
		SortTime sTime = null;
		
		if (sortType.equals ("InsertionSort"))
		{
			sTime = new SortTime(new InsertionSort(), t);
		}
		
		if (sortType.equals ("InsertionSortBinarySearch"))
		{
			sTime = new SortTime(new InsertionSortBinarySearch(), t);
		}
		
		if (sortType.equals ("MergeSort"))
		{
			sTime = new SortTime(new MergeSort(), t);
		}
		
		if (sortType.equals ("MergeInsertionSort"))
		{
			sTime = new SortTime(new MergeInsertionSort(), t);
		}
		
		if (sortType.equals("QuickSort"))
		{
			sTime = new SortTime(new QuickSort(), t);
		}
		
		if (sortType.equals ("QuickInsertionSort"))
		{
			sTime = new SortTime(new QuickInsertionSort(), t);
		}
		
		if (sortType.equals ("QuickSortMedian3"))
		{
			sTime = new SortTime(new QuickSortMedian3(), t);
		}
		
		if (sortType.equals ("QuickSortRandom"))
		{
			sTime = new SortTime(new QuickSortRandom(), t);
		}
		
		if (sortType.equals ("HeapSort"))
		{
			sTime = new SortTime(new HeapSort(), t);
		}
		
		if (sortType.equals ("SelectionSort"))
		{
			sTime = new SortTime(new SelectionSort(), t);
		}
		
		if (sortType.equals ("BubbleSort"))
		{
			sTime = new SortTime(new BubbleSort(), t);
		}
		
		if (sortType.equals ("ShellSort"))
		{
			sTime = new SortTime(new ShellSort(), t);
		}
		
		if (sortType.equals ("CombSort"))
		{
			sTime = new SortTime(new CombSort(), t);
		}
		
		
		//warm up sort call
		for (int i = 0; i < 3000; i++)
		{
			double dummy = sTime.sort(type,2);
		}
		
		//warm up some more
		for (int i = 0; i < 6; i++)
		{
			double dummy = sTime.sort (type, count);	
		}
		
		double totalTime = 0.0;
		for (int i = 0; i < tries; i++)
		{
			double tt = sTime.sort(type,count);
			totalTime = totalTime + tt;
			System.out.println (tt);
		}
		System.out.println (sortType + " " +count+ "  TIME: " + (totalTime / tries));
	}
}